# variables
LOOPS_PER_SECOND = 500
TIME_TO_WAIT = 1 / LOOPS_PER_SECOND


# PIN
LED_PIN = 25
SERVO_PIN = 18  # ORANGE
MOTOR_PIN_RIGHT_FRONT = 11
MOTOR_PIN_RIGHT_BACK = 10
MOTOR_PIN_LEFT_FRONT = 12
MOTOR_PIN_LEFT_BACK = 13
U_SENSOR_PIN_TRIGGER = 20  # GREEN
U_SENSOR_PIN_ECHO = 19  # VIOLET

# SERVO
SERVO_STEP = 10000
SERVO_FREQ = 50
SCAN_CENTER = 1500000
SCAN_MAX_RIGHT = 1280000
SCAN_MAX_LEFT = 1630000
N_SCAN_STEP_FULLSCAN = int((SCAN_MAX_LEFT-SCAN_MAX_RIGHT)/SERVO_STEP)
DIRECTION = 1

# THRESHOLDS
THRES_ALL_FREE = 50  # cm
THRES_OBSTACLE = 35  # cm
THRES_FULL_SCAN = 20  # cm
THRES_START = 2  # cm

# PWM MOTOR SPEEDS
PWM_MOTOR_FREQ = 500
PERIOD = 1 / PWM_MOTOR_FREQ * 1000000000
# THIS ARE REFERRED TO FREQ 500 -> PERIOD = 2ms = 2000us = 2000000ns
# 2/5 of the period (slower does not start sometimes)
ADAGIO = int(PERIOD * 0.5)
ANDANTE = int(PERIOD * 0.56)  # half of the period
MARCIA = int(PERIOD * 0.6)  # 3/5 of the period
ALLEGRO = int(PERIOD * 0.9)  # 3/4 of the period
PRESTO = int(PERIOD)  # full power
TURNING_TIME = 0.3
STOP = 0
GEARS = [STOP, ADAGIO, ANDANTE, MARCIA, ALLEGRO, PRESTO]
# CORREZIONE DELLA DIREZIONE: 1 means the robot is going straight, less/more than 1 means the robot is biased to the left/right,
DIR_CORRECTION = 1.15
# ENOUGH TIME TO SPEED UP
ENOUGH_TO_CHANGE_GEAR = 5*LOOPS_PER_SECOND

# GO CRAZY
DRIFT_COUNTER = 120*LOOPS_PER_SECOND

# FOR THE PINS
UP = 1
DOWN = 0
